/*
 *
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 *
 */

#pragma ident  "$Id: sysdep.h,v 1.1.1.1 2007/04/09 21:22:48 tw76360 Exp $ SMI"

#ifndef	_SYSDEP_H
#define	_SYSDEP_H

#include <sys/types.h>
#include <sys/time.h>
#include <sys/sysinfo.h>

#if defined(sun)
#include <sys/systeminfo.h>
#endif

/* set the following to the number of 100ns ticks of the actual
   resolution of
   your system's clock */

#define UUIDS_PER_TICK 1024

#define NODE_IDENTIFIER_LEN 1024
#define NODE_DOMAIN_LEN 1024
#define NODE_TIMEZONE_LEN 1024

/*
 * Set the following to a call to acquire a system wide global lock
 */

#define LOCK
#define UNLOCK

typedef unsigned long   unsigned32;
typedef unsigned short  unsigned16;
typedef unsigned char   unsigned8;
typedef unsigned char   byte;

#define unsigned64_t unsigned long long
#define I64(C) C##LL

typedef unsigned64_t uuid_time_t;
typedef struct {
  char id[6];
} uuid_node_t;

void get_ieee_node_identifier(uuid_node_t *node);
void get_system_time(uuid_time_t *uuid_time);

void get_node_identifier(char *node_identifier);
void get_node_domain(char *node_domain);
void get_node_timezone(char *node_timezone);

#endif
