/*
 *
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 *
 */

#pragma ident  "$Id: uuid.h,v 1.1.1.1 2007/04/09 21:22:48 tw76360 Exp $ SMI"

#ifndef	_UUID_H
#define	_UUID_H

#ifdef __cplusplus
extern "C" {
#endif

#include "sysdep.h"

/*
** Copyright (c) 1990- 1993, 1996 Open Software Foundation, Inc.
** Copyright (c) 1989 by Hewlett-Packard Company, Palo Alto, Ca. &
** Digital Equipment Corporation, Maynard, Mass.
** Copyright (c) 1998 Microsoft.
**
** To anyone who acknowledges that this file is provided "AS IS"
** without any express or implied warranty: permission to use, copy,
** modify, and distribute this file for any purpose is hereby granted
** without fee, provided that the above copyright notices and this
** notice appears in all source code copies, and that none of the
** names of Open Software Foundation, Inc., Hewlett-Packard Company,
** or Digital Equipment Corporation be used in advertising or
** publicity pertaining to distribution of the software without
** specific, written prior permission.  Neither Open Software
** Foundation, Inc., Hewlett-Packard Company, Microsoft, nor Digital
** Equipment Corporation makes any representations about the
** suitability of this software for any purpose.
*/

#undef uuid_t
typedef struct _uuid_t {
  unsigned32          time_low;
  unsigned16          time_mid;
  unsigned16          time_hi_and_version;
  unsigned8           clock_seq_hi_and_reserved;
  unsigned8           clock_seq_low;
  byte                node[6];
} uuid_t;

/* uuid_create -- generate a UUID */

int uuid_create(uuid_t * uuid);

/* size of the character representation of a uuid */
#define UUID_CHARLEN  40

/*
 * format a uuid as a character string.
 * The passed buffer is assumed to be at least UUID_CHARLEN in length
 */
void uuid_tostring(uuid_t *uuid, char *buf);
int uuid_fromstring(uuid_t *uuid, char *buf);


/* uuid_compare --  Compare two UUID's "lexically" and return
   -1   u1 is lexically before u2
   0   u1 is equal to u2
   1   u1 is lexically after u2
   Note:   lexical ordering is not temporal ordering!
*/
int uuid_compare(uuid_t *u1, uuid_t *u2);

#ifdef __cplusplus
}
#endif

#endif
