/*-------------------------------------------------*/
/* Probe                                           */
/*-------------------------------------------------*/

#include "probe.h"
#include "strlcpy.h"

/*
int main(int argc, char * argv[])
{

  struct probeStruct *probeData;
  probeData = malloc(sizeof(struct probeStruct));
  if (!probeData)
  {
    printf("malloc failure");
    return -1;
  }
  get_probe_data(probeData);
  int i = 0;
  for (i = 0; i < MAX_SYSCONF_FIELDS; i++)
  {
    printf("%s=%s\n", sysconfField[i], probeData->sysconf[i]);
  }

  free(probeData);
  return 0;
}
*/

void get_probe_data(struct probeStruct *probeData)
{
  struct utsname u;
  /*int num_procs;*/
  char hostid[MAX_SYSCONF_BUF_LEN];
  char psn[MAX_SYSCONF_BUF_LEN];
  char manufacturer[MAX_SYSCONF_BUF_LEN];
  char cpu_manufacturer[MAX_SYSCONF_BUF_LEN];
  char product_name[MAX_SYSCONF_BUF_LEN];

  /* init our cpubuffer */
  (void) init(0);

  /*num_procs = getNumProcs();*/

  uname (&u);
  strcpy(probeData->sysconf[SI_SYSTEM], u.sysname);
  strcpy(probeData->sysconf[SI_HOST], u.nodename);
  strcpy(probeData->sysconf[SI_RELEASE], u.release);
  strcpy(probeData->sysconf[SI_ARCH], u.machine);
  strcpy(probeData->sysconf[SI_PLATFORM], "");

  read_psn_file(psn, manufacturer, cpu_manufacturer, product_name,
                MAX_SYSCONF_BUF_LEN);

  strcpy(probeData->sysconf[SI_MANUFACTURER], manufacturer);
  strcpy(probeData->sysconf[SI_CPU_MANUFACTURER], cpu_manufacturer);
  strcpy(probeData->sysconf[SI_SERIAL_NUMBER], psn);
  strlcpy(probeData->sysconf[SI_PLATFORM], product_name, MAX_SYSCONF_BUF_LEN);
  sprintf(hostid, "%lx", gethostid());
  strlcpy(probeData->sysconf[SI_HOSTID], hostid, MAX_SYSCONF_BUF_LEN);
}

int getNumProcs()
{
  char *line;
  int cnt = 0;
  char tmp[64];
  char buf[strlen(cpubuffer)];
  strcpy(buf, cpubuffer);
  line = strtok(buf, "\n");
  if (sscanf(line,"processor : %s",tmp))
  {
    cnt++;
  }
  while ((line = strtok(NULL,"\n")) != NULL)
  {
    if (sscanf(line,"processor : %s",tmp))
    {
      cnt++;
    }
  }
  return cnt;
}

/* tries to read from /var/run/psn for the chassis serial number,
 * manufacturer, and cpu_manufacturer.
 *
 * Assumes that chassis_sn has already been allocated.
 * Assumes that manufacturer has already been allocated.
 * Assumes that cpu_manufacturer has already been allocated.
 */
void
read_psn_file(char *chassis_sn, char *manufacturer,
              char *cpu_manufacturer, char *product_name, int max_len)
{
  /*char *tmp;*/
  char csn_buf[1024];
  char *line;
  FILE *ptr;
  /*struct stat stat_buf;*/
  char cmd[256];
  int cnt = 0;
  int found_chassis_sn = 0;
  int found_manufacturer = 0;
  int found_cpu_manufacturer = 0;
  int found_product_name = 0;
  static char *empty = "";

  sprintf(cmd, "cat %s 2> /dev/null", "/var/run/psn");

  if ((ptr = popen(cmd, "r")) != NULL)
  {
    while (fgets(csn_buf, 1024, ptr) != NULL)
    {
      /* Deal with a blank or empty line */

      int llen = strlen(csn_buf);
      line = strtok(csn_buf, "\n");
      
      char *bline = (line == NULL || llen <= 1) ? empty : line;

      if (cnt == 0)
      {
        if (strncmp("__NONE__", bline, 8) != 0
            && strncmp(" __NONE__", bline, 9) != 0) {
          strlcpy(chassis_sn, bline, max_len);
          found_chassis_sn = 1;
        }
      }
      else if (cnt == 1)
      {
        if (strncmp("__NONE__", bline, 8) != 0
            && strncmp(" __NONE__", bline, 9) != 0) {
          strlcpy(manufacturer, bline, max_len);
          found_manufacturer = 1;
        }
      }
      else if (cnt == 2)
      {
        if (strncmp("__NONE__", bline, 8) != 0
            && strncmp(" __NONE__", bline, 9) != 0) {
          strlcpy(cpu_manufacturer, bline, max_len);
          found_cpu_manufacturer = 1;
        }
      }
      else if (cnt == 3)
      {
        if (strncmp("__NONE__", bline, 8) != 0
            && strncmp(" __NONE__", bline, 9) != 0) {
          strlcpy(product_name, bline, max_len);
          found_product_name = 1;
        }
      }

      cnt++;
    }
    (void) pclose(ptr);
  }

  if (!found_chassis_sn) {
    strlcpy(chassis_sn, "\0", max_len);
  }
  if (!found_manufacturer) {
    strlcpy(manufacturer, "\0", max_len);
  }
  if (!found_cpu_manufacturer) {
    strlcpy(cpu_manufacturer, "\0", max_len);
  }

  if (!found_product_name) {
    strlcpy(product_name, "\0", max_len);
  }
}

static int init(int type)
{
    FILE* fp;
    size_t bytes_read;

    if (type == 0)
    {
      /* Read the entire contents of /proc/cpuinfo into cpubuffer. */
      fp = fopen ("/proc/cpuinfo", "r");
      if (fp == NULL)
      {
        return 0;
      }

      bytes_read = fread (cpubuffer, 1, sizeof (cpubuffer), fp);
      fclose (fp);

      if (bytes_read == 0 || bytes_read == sizeof (cpubuffer))
      {
        return 0;
      }

      cpubuffer[bytes_read] = '\0';

      return strlen(cpubuffer);
    }
    else if (type == 1)
    {
      /* Read the entire contents of /proc/meminfo into membuffer. */
      fp = fopen ("/proc/meminfo", "r");
      if (fp == NULL)
      {
        return 0;
      }

      bytes_read = fread (membuffer, 1, sizeof (membuffer), fp);
      fclose (fp);

      if (bytes_read == 0 || bytes_read == sizeof (membuffer))
      {
        return 0;
      }

      membuffer[bytes_read] = '\0';

      return strlen(membuffer);
    }

    return(0);	/* NOTREACHED */
}
